/*
	Lmpqapi.cpp
*/

#include "lmpqapi.h"

struct LMPQAPIMODULE {
	LMPQAPIMODULE();
	~LMPQAPIMODULE();
} LMpqApi;

HINSTANCE hLMpq = 0;

funcMpqInitialize MpqInitialize = 0;
funcMpqGetVersionString MpqGetVersionString = 0;
funcMpqGetVersion MpqGetVersion = 0;

// Staredit Function Names
funcMpqOpenArchiveForUpdate MpqOpenArchiveForUpdate = 0;
funcMpqCloseUpdatedArchive MpqCloseUpdatedArchive = 0;
funcMpqAddFileToArchive MpqAddFileToArchive = 0;
funcMpqAddWaveToArchive MpqAddWaveToArchive = 0;
funcMpqRenameFile MpqRenameFile = 0;
funcMpqDeleteFile MpqDeleteFile = 0;
funcMpqCompactArchive MpqCompactArchive = 0;

// Storm Function Names
funcSFileOpenArchive SFileOpenArchive = 0;
funcSFileCloseArchive SFileCloseArchive = 0;
funcSFileOpenFileEx SFileOpenFileEx = 0;
funcSFileCloseFile SFileCloseFile = 0;
funcSFileGetFileSize SFileGetFileSize = 0;
funcSFileGetFileInfo SFileGetFileInfo = 0;
funcSFileSetFilePointer SFileSetFilePointer = 0;
funcSFileReadFile SFileReadFile = 0;
funcSFileSetLocale SFileSetLocale = 0;

LMPQAPIMODULE::LMPQAPIMODULE()
{
	LoadLmpqApiDllFunctions("Lmpqapi.dll");
}

LMPQAPIMODULE::LMPQAPIMODULE()
{
	MpqInitialize = 0;
	MpqGetVersionString = 0;
	MpqGetVersion = 0;
	MpqOpenArchiveForUpdate = 0;
	MpqCloseUpdatedArchive = 0;
	MpqAddFileToArchive = 0;
	MpqAddWaveToArchive = 0;
	MpqRenameFile = 0;
	MpqDeleteFile = 0;
	MpqCompactArchive = 0;
	SFileOpenArchive = 0;
	SFileCloseArchive = 0;
	SFileOpenFileEx = 0;
	SFileCloseFile = 0;
	SFileGetFileSize = 0;
	SFileGetFileInfo = 0;
	SFileSetFilePointer = 0;
	SFileReadFile = 0;
	SFileSetLocale = 0;

	if (hLMpq==0) return;
	FreeLibrary(hLMpq);
	hLMpq = 0;
}

HINSTANCE LoadLmpqApiDllFunctions(char * DllFileName)
{
	if (hLMpq!=0) return 0;
	hLMpq = LoadLibrary(DllFileName);

	if (hLMpq != NULL)
	{
		MpqInitialize = (funcMpqInitialize)GetProcAddress(hLMpq, "MpqInitialize");
		MpqGetVersionString = (funcMpqGetVersionString)GetProcAddress(hLMpq, "MpqGetVersionString");
		MpqGetVersion = (funcMpqGetVersion)GetProcAddress(hLMpq, "MpqGetVersion");
		MpqOpenArchiveForUpdate = (funcMpqOpenArchiveForUpdate)GetProcAddress(hLMpq, "MpqOpenArchiveForUpdate");
		MpqCloseUpdatedArchive = (funcMpqCloseUpdatedArchive)GetProcAddress(hLMpq, "MpqCloseUpdatedArchive");
		MpqAddFileToArchive = (funcMpqAddFileToArchive)GetProcAddress(hLMpq, "MpqAddFileToArchive");
		MpqAddWaveToArchive = (funcMpqAddWaveToArchive)GetProcAddress(hLMpq, "MpqAddWaveToArchive");
		MpqRenameFile = (funcMpqRenameFile)GetProcAddress(hLMpq, "MpqRenameFile");
		MpqDeleteFile = (funcMpqDeleteFile)GetProcAddress(hLMpq, "MpqDeleteFile");
		MpqCompactArchive = (funcMpqCompactArchive)GetProcAddress(hLMpq, "MpqCompactArchive");
		SFileOpenArchive = (funcSFileOpenArchive)GetProcAddress(hLMpq, "SFileOpenArchive");
		SFileCloseArchive = (funcSFileCloseArchive)GetProcAddress(hLMpq, "SFileCloseArchive");
		SFileOpenFileEx = (funcSFileOpenFileEx)GetProcAddress(hLMpq, "SFileOpenFileEx");
		SFileCloseFile = (funcSFileCloseFile)GetProcAddress(hLMpq, "SFileCloseFile");
		SFileGetFileSize = (funcSFileGetFileSize)GetProcAddress(hLMpq, "SFileGetFileSize");
		SFileGetFileInfo = (funcSFileGetFileInfo)GetProcAddress(hLMpq, "SFileGetFileInfo");
		SFileSetFilePointer = (funcSFileSetFilePointer)GetProcAddress(hLMpq, "SFileSetFilePointer");
		SFileReadFile = (funcSFileReadFile)GetProcAddress(hLMpq, "SFileReadFile");
		SFileSetLocale = (funcSFileSetLocale)GetProcAddress(hLMpq, "SFileSetLocale");
	}
	return hLMpq;
}

